-- main.lua for looking_glass

require 'colors'
require 'shortcuts'
require 'keyboard'
require 'looking_glass'

function love.load()
	help = require'help'
	help.load()
	show = {help=true}
	screenWidth, screenHeight = 800, 600
	gr.setBackgroundColor( 55, 55, 55 )
	lg = {			-- looking_glass params
		x		= 0.5,
		y		= 0.5,
		size	= 0.15,
		mag		= 2.0,
		fog		= 0.1,
		}
	for i,j in pairs(lg) do looking_glass:send(i,j) end
	background = gr.newImage( 'glass.jpg' )
	canvas = gr.newCanvas()
	function loadCanvas()
		canvas:clear()
		gr.setCanvas( canvas )
		gr.draw( background,0,0,0,1,1)
		gr.setCanvas()
		end
	function ellipse( mode, x, y, rx, ry, res )
		res = res or rx / 5 > 20 and rx / 5 or 20
		local pts, step, mode = {}, 2*pi/res, 'line'
		for i = 1, res do
			cx = rx * cos( (i-1) * step ) + x
			ti( pts, cx )
			cy = ry * sin( (i-1) * step ) + y
			ti( pts, cy )
			end
		gr.polygon( mode, unpack( pts ) )
		end

	function addBorder()
		gr.setColor( to 'blue')
		ellipse( 'line',
			lg.x*screenWidth,
			screenHeight-lg.y*screenHeight,
			screenWidth*lg.size,
			screenHeight*lg.size )
		gr.setColor( to 'white' )
		end
	end

function love.update( dt )
	keyboard_update( dt )
	end

function love.draw()
	loadCanvas()
	gr.setPixelEffect( looking_glass )		-- pixel effect looks at entire canvas
	gr.draw( canvas )						-- looking_glass changes only window area
	gr.setPixelEffect()
	addBorder()
	help.draw()
	end

